#some standard macros


#sections

	.macro code
	.section code, "awx", @progbits
	.endm

	#character data section
	.macro cdata
	.section cdata, "awx", @progbits
	.endm

	#32-bit aligned data section
	.macro data
	.section data, "awx", @progbits
	.endm

	.macro space
	.section space, "awx", @nobits
	.endm

	#prolog/epilog

	.macro prolog
	mflr r0
	stwu r0,-4(r1)
	.endm

	.macro _epilog
	lwz r0,0(r1)
	addi r1,r1,4
	mtlr r0
	.endm

	.macro epilog
	_epilog
	blr
	.endm

#constants

	.set false, 0
	.set true, (~0)

#pseudo-asm instructions

	#load 32-bit immediate to a register
	.macro liw reg,value
	lis \reg,\value@ha
	addi \reg,\reg,\value@l
	.endm

	#fetch word from immediate address
	.macro lwzi reg1,reg2,value
	lis \reg2,\value@ha
	lwz \reg1,\value@l(\reg2)
	.endm

	#store word to immediate address
	.macro stwi reg1,reg2,value
	lis \reg2,\value@ha
	stw \reg1,\value@l(\reg2)
	.endm

	#define a counted string
	.macro message string
	.byte 0f-(.+1)
	.byte "\string"
	.byte 13, 10  #CR LF
0:
	.endm
