#Internals for Open Firmware interface.


#Defines for an argument array structure.

	.set service, 0
	.set n_args, 4
	.set n_ret, 8
	.set arg0, 12


#The various (constant) strings that we use.

	cdata

#device names
chosen_str:	.string "/chosen"

#property names
stdin_str:	.string "stdin"
stdout_str:	.string "stdout"

#services
finddevice_str:	.string "finddevice"
getprop_str:	.string "getprop"
open_str:	.string "open"
close_str:	.string "close"
read_str:	.string "read"
write_str:	.string "write"
seek_str:	.string "seek"
claim_str:	.string "claim"
release_str:	.string "release"
exit_str:	.string "exit"
ms_str:		.string "milliseconds"
fail_str:	.string "fail"

#Macro/routine to actually make the call to Open Firmware.
	#Note that, in addition to any return values in the
	#argument array, OF also returns a -1 in r3 if it failed
	#to call the requested service, or a 0 if it did make the
	#call.  However, I am currently ignoring this.

	.macro ofcall service_str
	liw r4,\service_str
	stw r4,service(r3)
	bl of_call
	twnei r3,0  #check for OF errors.
	.endm

	code

of_call:
	lwzi r4,r5,of_entry
	mtctr r4
	bctr


#Macro/routines to set n_args, n_ret, and clear return value (if
#any), for the various values of n_args and n_ret that we use.
#Also macro to get return value.

	.macro set_n n_args,n_ret
	#set n_args and n_ret.
	.if \n_args <> \n_ret
	li r4,\n_args
	li r5,\n_ret
	stw r4,n_args(r3)
	stw r5,n_ret(r3)
	.else
	li r4,\n_args
	stw r4,n_args(r3)
	stw r4,n_ret(r3)
	.endif
	#clear return value (if there is one).
	.if \n_ret
	li r4,0
	stw r4,arg0+\n_args<<2(r3)
	.endif
	.endm

	.macro get_retval n_args
	lwzi r3,r4,args+arg0+\n_args<<2
	.endm

	code

args_0_0:
	liw r3,args
	set_n 0,0
	blr

args_0_1:
	liw r3,args
	set_n 0,1
	blr

args_1_0:
	liw r4,args
	stw r3,arg0(r4)
	mr r3,r4
	set_n 1,0
	blr

args_1_1:
	liw r4,args
	stw r3,arg0(r4)
	mr r3,r4
	set_n 1,1
	blr

args_2_0:
	liw r5,args
	stw r3,arg0(r5)
	stw r4,arg0+4(r5)
	mr r3,r5
	set_n 2,0
	blr

args_3_1:
	liw r6,args
	stw r3,arg0(r6)
	stw r4,arg0+4(r6)
	stw r5,arg0+8(r6)
	mr r3,r6
	set_n 3,1
	blr

args_4_1:
	liw r7,args
	stw r3,arg0(r7)
	stw r4,arg0+4(r7)
	stw r5,arg0+8(r7)
	stw r6,arg0+12(r7)
	mr r3,r7
	set_n 4,1
	blr
